# This file is responsible for configuring your application
# and its dependencies with the aid of the Mix.Config module.
#
# This configuration file is loaded before any dependency and
# is restricted to this project.

# General application configuration
use Mix.Config

config :meta,
  namespace: Meta,
  ecto_repos: [Meta.Repo],
  enable_registration: true

# Configures the endpoint
config :meta, MetaWeb.Endpoint,
  url: [host: "localhost"],
  secret_key_base: "bm4MGjSLcEbL3HEDg2H0LlcJ5d3nIkogyd/PpGW1iXdEbKbtM0N8Ct4Jh/PbsnoS",
  render_errors: [view: MetaWeb.ErrorView, accepts: ~w(html json), layout: false],
  pubsub_server: Meta.PubSub,
  live_view: [signing_salt: "kTyyWZd5"]

# Configures Elixir's Logger
config :logger, :console,
  format: "$time $metadata[$level] $message\n",
  metadata: [:request_id]

# Use Jason for JSON parsing in Phoenix
config :phoenix, :json_library, Jason

# Import environment specific config. This must remain at the bottom
# of this file so it overrides the configuration defined above.
import_config "#{Mix.env()}.exs"
