defmodule Meta do
  @moduledoc """
  Meta keeps the contexts that define your domain
  and business logic.

  Contexts are also responsible for managing your data, regardless
  if it comes from the database, an external API or others.
  """

  # Mix is not available in releases, and these things are static
  # anyway (@variables are evaluated at compile time).
  @version Mix.Project.config[:version]
  @env Mix.env

  def version, do: @version
  def env, do: @env
end
