%% HRL file generated by ERLSOM
%%
%% It is possible (and in some cases necessary) to change the name of
%% the record fields.
%%
%% It is possible to add default values, but be aware that these will
%% only be used when *writing* an xml document.


-ifndef(ERLSOM_ANY_ATTRIB_TYPES).
-define(ERLSOM_ANY_ATTRIB_TYPES, true).
-type anyAttrib()  :: {{string(),    %% name of the attribute
                        string()},   %% namespace
                       string()}.    %% value

-type anyAttribs() :: [anyAttrib()] | undefined.
-endif.

-ifndef(ERLSOM_QNAME_TYPES).
-define(ERLSOM_QNAME_TYPES, true).
%% xsd:QName values are translated to #qname{} records.
-record(qname, {uri :: string(),
                localPart :: string(),
                prefix :: string(),
                mappedPrefix :: string()}).
-endif.



-record('HISTORY', {anyAttribs :: anyAttribs(),
	'OID' :: integer(),
	'SEQ' :: integer(),
	'HOSTNAME' :: string(),
	'HID' :: integer(),
	'CID' :: integer(),
	'STIME' :: integer(),
	'ETIME' :: integer(),
	'VM_MAD' :: string(),
	'TM_MAD' :: string(),
	'DS_ID' :: integer(),
	'PSTIME' :: integer(),
	'PETIME' :: integer(),
	'RSTIME' :: integer(),
	'RETIME' :: integer(),
	'ESTIME' :: integer(),
	'EETIME' :: integer(),
	'ACTION' :: integer(),
	'UID' :: integer(),
	'GID' :: integer(),
	'REQUEST_ID' :: string(),
	'VM' :: 'HISTORY/VM'()}).

-type 'HISTORY'() :: #'HISTORY'{}.


-record('HISTORY/VM', {anyAttribs :: anyAttribs(),
	'ID' :: integer(),
	'UID' :: integer(),
	'GID' :: integer(),
	'UNAME' :: string(),
	'GNAME' :: string(),
	'NAME' :: string(),
	'PERMISSIONS' :: 'HISTORY/VM/PERMISSIONS'() | undefined,
	'LAST_POLL' :: integer(),
	'STATE' :: integer(),
	'LCM_STATE' :: integer(),
	'PREV_STATE' :: integer(),
	'PREV_LCM_STATE' :: integer(),
	'RESCHED' :: integer(),
	'STIME' :: integer(),
	'ETIME' :: integer(),
	'DEPLOY_ID' :: string(),
	'MONITORING' :: string(),
	'TEMPLATE' :: string(),
	'USER_TEMPLATE' :: string(),
	'HISTORY_RECORDS' :: string(),
	'SNAPSHOTS' :: ['HISTORY/VM/SNAPSHOTS'()] | undefined}).

-type 'HISTORY/VM'() :: #'HISTORY/VM'{}.


-record('HISTORY/VM/SNAPSHOTS', {anyAttribs :: anyAttribs(),
	'ALLOW_ORPHANS' :: string(),
	'CURRENT_BASE' :: integer(),
	'DISK_ID' :: integer(),
	'NEXT_SNAPSHOT' :: integer(),
	'SNAPSHOT' :: ['HISTORY/VM/SNAPSHOTS/SNAPSHOT'()] | undefined}).

-type 'HISTORY/VM/SNAPSHOTS'() :: #'HISTORY/VM/SNAPSHOTS'{}.


-record('HISTORY/VM/SNAPSHOTS/SNAPSHOT', {anyAttribs :: anyAttribs(),
	'ACTIVE' :: string() | undefined,
	'CHILDREN' :: string() | undefined,
	'DATE' :: integer(),
	'ID' :: integer(),
	'NAME' :: string() | undefined,
	'PARENT' :: integer(),
	'SIZE' :: integer()}).

-type 'HISTORY/VM/SNAPSHOTS/SNAPSHOT'() :: #'HISTORY/VM/SNAPSHOTS/SNAPSHOT'{}.


-record('HISTORY/VM/PERMISSIONS', {anyAttribs :: anyAttribs(),
	'OWNER_U' :: integer(),
	'OWNER_M' :: integer(),
	'OWNER_A' :: integer(),
	'GROUP_U' :: integer(),
	'GROUP_M' :: integer(),
	'GROUP_A' :: integer(),
	'OTHER_U' :: integer(),
	'OTHER_M' :: integer(),
	'OTHER_A' :: integer()}).

-type 'HISTORY/VM/PERMISSIONS'() :: #'HISTORY/VM/PERMISSIONS'{}.


-record('HISTORY_RECORDS', {anyAttribs :: anyAttribs(),
	'HISTORY_RECORDS/SEQ1' :: 'HISTORY_RECORDS/SEQ1'() | undefined}).

-type 'HISTORY_RECORDS'() :: #'HISTORY_RECORDS'{}.


-record('HISTORY_RECORDS/SEQ1', {anyAttribs :: anyAttribs(),
	'HISTORY' :: ['HISTORY'()] | undefined}).

-type 'HISTORY_RECORDS/SEQ1'() :: #'HISTORY_RECORDS/SEQ1'{}.