%% HRL file generated by ERLSOM
%%
%% It is possible (and in some cases necessary) to change the name of
%% the record fields.
%%
%% It is possible to add default values, but be aware that these will
%% only be used when *writing* an xml document.


-ifndef(ERLSOM_ANY_ATTRIB_TYPES).
-define(ERLSOM_ANY_ATTRIB_TYPES, true).
-type anyAttrib()  :: {{string(),    %% name of the attribute
                        string()},   %% namespace
                       string()}.    %% value

-type anyAttribs() :: [anyAttrib()] | undefined.
-endif.

-ifndef(ERLSOM_QNAME_TYPES).
-define(ERLSOM_QNAME_TYPES, true).
%% xsd:QName values are translated to #qname{} records.
-record(qname, {uri :: string(),
                localPart :: string(),
                prefix :: string(),
                mappedPrefix :: string()}).
-endif.



-record('DATASTORE', {anyAttribs :: anyAttribs(),
	'ID' :: integer(),
	'UID' :: integer(),
	'GID' :: integer(),
	'UNAME' :: string(),
	'GNAME' :: string(),
	'NAME' :: string(),
	'PERMISSIONS' :: 'DATASTORE/PERMISSIONS'() | undefined,
	'DS_MAD' :: string(),
	'TM_MAD' :: string(),
	'BASE_PATH' :: string(),
	'TYPE' :: integer(),
	'DISK_TYPE' :: integer(),
	'STATE' :: integer(),
	'CLUSTERS' :: 'DATASTORE/CLUSTERS'(),
	'TOTAL_MB' :: integer(),
	'FREE_MB' :: integer(),
	'USED_MB' :: integer(),
	'IMAGES' :: 'DATASTORE/IMAGES'(),
	'TEMPLATE' :: 'DATASTORE/TEMPLATE'()}).

-type 'DATASTORE'() :: #'DATASTORE'{}.


-record('DATASTORE/TEMPLATE', {anyAttribs :: anyAttribs(),
	'VCENTER_DC_NAME' :: string() | undefined,
	'VCENTER_DC_REF' :: string() | undefined,
	'VCENTER_DS_NAME' :: string() | undefined,
	'VCENTER_DS_REF' :: string() | undefined,
	'VCENTER_HOST' :: string() | undefined,
	'VCENTER_INSTANCE_ID' :: string() | undefined,
	'#any' :: any()}).

-type 'DATASTORE/TEMPLATE'() :: #'DATASTORE/TEMPLATE'{}.


-record('DATASTORE/IMAGES', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'DATASTORE/IMAGES'() :: #'DATASTORE/IMAGES'{}.


-record('DATASTORE/CLUSTERS', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'DATASTORE/CLUSTERS'() :: #'DATASTORE/CLUSTERS'{}.


-record('DATASTORE/PERMISSIONS', {anyAttribs :: anyAttribs(),
	'OWNER_U' :: integer(),
	'OWNER_M' :: integer(),
	'OWNER_A' :: integer(),
	'GROUP_U' :: integer(),
	'GROUP_M' :: integer(),
	'GROUP_A' :: integer(),
	'OTHER_U' :: integer(),
	'OTHER_M' :: integer(),
	'OTHER_A' :: integer()}).

-type 'DATASTORE/PERMISSIONS'() :: #'DATASTORE/PERMISSIONS'{}.