%% HRL file generated by ERLSOM
%%
%% It is possible (and in some cases necessary) to change the name of
%% the record fields.
%%
%% It is possible to add default values, but be aware that these will
%% only be used when *writing* an xml document.


-ifndef(ERLSOM_ANY_ATTRIB_TYPES).
-define(ERLSOM_ANY_ATTRIB_TYPES, true).
-type anyAttrib()  :: {{string(),    %% name of the attribute
                        string()},   %% namespace
                       string()}.    %% value

-type anyAttribs() :: [anyAttrib()] | undefined.
-endif.

-ifndef(ERLSOM_QNAME_TYPES).
-define(ERLSOM_QNAME_TYPES, true).
%% xsd:QName values are translated to #qname{} records.
-record(qname, {uri :: string(),
                localPart :: string(),
                prefix :: string(),
                mappedPrefix :: string()}).
-endif.



-record('GROUP', {anyAttribs :: anyAttribs(),
	'ID' :: integer(),
	'NAME' :: string(),
	'TEMPLATE' :: string(),
	'USERS' :: 'GROUP/USERS'(),
	'ADMINS' :: 'GROUP/ADMINS'(),
	'DATASTORE_QUOTA' :: 'GROUP/DATASTORE_QUOTA'() | undefined,
	'NETWORK_QUOTA' :: 'GROUP/NETWORK_QUOTA'() | undefined,
	'VM_QUOTA' :: 'GROUP/VM_QUOTA'() | undefined,
	'IMAGE_QUOTA' :: 'GROUP/IMAGE_QUOTA'() | undefined,
	'DEFAULT_GROUP_QUOTAS' :: 'GROUP/DEFAULT_GROUP_QUOTAS'()}).

-type 'GROUP'() :: #'GROUP'{}.


-record('GROUP/DEFAULT_GROUP_QUOTAS', {anyAttribs :: anyAttribs(),
	'DATASTORE_QUOTA' :: 'GROUP/DEFAULT_GROUP_QUOTAS/DATASTORE_QUOTA'() | undefined,
	'NETWORK_QUOTA' :: 'GROUP/DEFAULT_GROUP_QUOTAS/NETWORK_QUOTA'() | undefined,
	'VM_QUOTA' :: 'GROUP/DEFAULT_GROUP_QUOTAS/VM_QUOTA'() | undefined,
	'IMAGE_QUOTA' :: 'GROUP/DEFAULT_GROUP_QUOTAS/IMAGE_QUOTA'() | undefined}).

-type 'GROUP/DEFAULT_GROUP_QUOTAS'() :: #'GROUP/DEFAULT_GROUP_QUOTAS'{}.


-record('GROUP/DEFAULT_GROUP_QUOTAS/IMAGE_QUOTA', {anyAttribs :: anyAttribs(),
	'IMAGE' :: ['GROUP/DEFAULT_GROUP_QUOTAS/IMAGE_QUOTA/IMAGE'()] | undefined}).

-type 'GROUP/DEFAULT_GROUP_QUOTAS/IMAGE_QUOTA'() :: #'GROUP/DEFAULT_GROUP_QUOTAS/IMAGE_QUOTA'{}.


-record('GROUP/DEFAULT_GROUP_QUOTAS/IMAGE_QUOTA/IMAGE', {anyAttribs :: anyAttribs(),
	'ID' :: string(),
	'RVMS' :: string(),
	'RVMS_USED' :: string()}).

-type 'GROUP/DEFAULT_GROUP_QUOTAS/IMAGE_QUOTA/IMAGE'() :: #'GROUP/DEFAULT_GROUP_QUOTAS/IMAGE_QUOTA/IMAGE'{}.


-record('GROUP/DEFAULT_GROUP_QUOTAS/VM_QUOTA', {anyAttribs :: anyAttribs(),
	'VM' :: 'GROUP/DEFAULT_GROUP_QUOTAS/VM_QUOTA/VM'() | undefined}).

-type 'GROUP/DEFAULT_GROUP_QUOTAS/VM_QUOTA'() :: #'GROUP/DEFAULT_GROUP_QUOTAS/VM_QUOTA'{}.


-record('GROUP/DEFAULT_GROUP_QUOTAS/VM_QUOTA/VM', {anyAttribs :: anyAttribs(),
	'CPU' :: string(),
	'CPU_USED' :: string(),
	'MEMORY' :: integer(),
	'MEMORY_USED' :: integer(),
	'RUNNING_CPU' :: string(),
	'RUNNING_CPU_USED' :: string(),
	'RUNNING_MEMORY' :: integer(),
	'RUNNING_MEMORY_USED' :: integer(),
	'RUNNING_VMS' :: integer(),
	'RUNNING_VMS_USED' :: integer(),
	'SYSTEM_DISK_SIZE' :: string(),
	'SYSTEM_DISK_SIZE_USED' :: string(),
	'VMS' :: integer(),
	'VMS_USED' :: integer()}).

-type 'GROUP/DEFAULT_GROUP_QUOTAS/VM_QUOTA/VM'() :: #'GROUP/DEFAULT_GROUP_QUOTAS/VM_QUOTA/VM'{}.


-record('GROUP/DEFAULT_GROUP_QUOTAS/NETWORK_QUOTA', {anyAttribs :: anyAttribs(),
	'NETWORK' :: ['GROUP/DEFAULT_GROUP_QUOTAS/NETWORK_QUOTA/NETWORK'()] | undefined}).

-type 'GROUP/DEFAULT_GROUP_QUOTAS/NETWORK_QUOTA'() :: #'GROUP/DEFAULT_GROUP_QUOTAS/NETWORK_QUOTA'{}.


-record('GROUP/DEFAULT_GROUP_QUOTAS/NETWORK_QUOTA/NETWORK', {anyAttribs :: anyAttribs(),
	'ID' :: string(),
	'LEASES' :: string(),
	'LEASES_USED' :: string()}).

-type 'GROUP/DEFAULT_GROUP_QUOTAS/NETWORK_QUOTA/NETWORK'() :: #'GROUP/DEFAULT_GROUP_QUOTAS/NETWORK_QUOTA/NETWORK'{}.


-record('GROUP/DEFAULT_GROUP_QUOTAS/DATASTORE_QUOTA', {anyAttribs :: anyAttribs(),
	'DATASTORE' :: ['GROUP/DEFAULT_GROUP_QUOTAS/DATASTORE_QUOTA/DATASTORE'()] | undefined}).

-type 'GROUP/DEFAULT_GROUP_QUOTAS/DATASTORE_QUOTA'() :: #'GROUP/DEFAULT_GROUP_QUOTAS/DATASTORE_QUOTA'{}.


-record('GROUP/DEFAULT_GROUP_QUOTAS/DATASTORE_QUOTA/DATASTORE', {anyAttribs :: anyAttribs(),
	'ID' :: string(),
	'IMAGES' :: string(),
	'IMAGES_USED' :: string(),
	'SIZE' :: string(),
	'SIZE_USED' :: string()}).

-type 'GROUP/DEFAULT_GROUP_QUOTAS/DATASTORE_QUOTA/DATASTORE'() :: #'GROUP/DEFAULT_GROUP_QUOTAS/DATASTORE_QUOTA/DATASTORE'{}.


-record('GROUP/IMAGE_QUOTA', {anyAttribs :: anyAttribs(),
	'IMAGE' :: ['GROUP/IMAGE_QUOTA/IMAGE'()] | undefined}).

-type 'GROUP/IMAGE_QUOTA'() :: #'GROUP/IMAGE_QUOTA'{}.


-record('GROUP/IMAGE_QUOTA/IMAGE', {anyAttribs :: anyAttribs(),
	'ID' :: string(),
	'RVMS' :: string(),
	'RVMS_USED' :: string()}).

-type 'GROUP/IMAGE_QUOTA/IMAGE'() :: #'GROUP/IMAGE_QUOTA/IMAGE'{}.


-record('GROUP/VM_QUOTA', {anyAttribs :: anyAttribs(),
	'VM' :: 'GROUP/VM_QUOTA/VM'() | undefined}).

-type 'GROUP/VM_QUOTA'() :: #'GROUP/VM_QUOTA'{}.


-record('GROUP/VM_QUOTA/VM', {anyAttribs :: anyAttribs(),
	'CPU' :: string(),
	'CPU_USED' :: string(),
	'MEMORY' :: integer(),
	'MEMORY_USED' :: integer(),
	'RUNNING_CPU' :: string(),
	'RUNNING_CPU_USED' :: string(),
	'RUNNING_MEMORY' :: integer(),
	'RUNNING_MEMORY_USED' :: integer(),
	'RUNNING_VMS' :: integer(),
	'RUNNING_VMS_USED' :: integer(),
	'SYSTEM_DISK_SIZE' :: string(),
	'SYSTEM_DISK_SIZE_USED' :: string(),
	'VMS' :: integer(),
	'VMS_USED' :: integer()}).

-type 'GROUP/VM_QUOTA/VM'() :: #'GROUP/VM_QUOTA/VM'{}.


-record('GROUP/NETWORK_QUOTA', {anyAttribs :: anyAttribs(),
	'NETWORK' :: ['GROUP/NETWORK_QUOTA/NETWORK'()] | undefined}).

-type 'GROUP/NETWORK_QUOTA'() :: #'GROUP/NETWORK_QUOTA'{}.


-record('GROUP/NETWORK_QUOTA/NETWORK', {anyAttribs :: anyAttribs(),
	'ID' :: string(),
	'LEASES' :: string(),
	'LEASES_USED' :: string()}).

-type 'GROUP/NETWORK_QUOTA/NETWORK'() :: #'GROUP/NETWORK_QUOTA/NETWORK'{}.


-record('GROUP/DATASTORE_QUOTA', {anyAttribs :: anyAttribs(),
	'DATASTORE' :: ['GROUP/DATASTORE_QUOTA/DATASTORE'()] | undefined}).

-type 'GROUP/DATASTORE_QUOTA'() :: #'GROUP/DATASTORE_QUOTA'{}.


-record('GROUP/DATASTORE_QUOTA/DATASTORE', {anyAttribs :: anyAttribs(),
	'ID' :: string(),
	'IMAGES' :: string(),
	'IMAGES_USED' :: string(),
	'SIZE' :: string(),
	'SIZE_USED' :: string()}).

-type 'GROUP/DATASTORE_QUOTA/DATASTORE'() :: #'GROUP/DATASTORE_QUOTA/DATASTORE'{}.


-record('GROUP/ADMINS', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'GROUP/ADMINS'() :: #'GROUP/ADMINS'{}.


-record('GROUP/USERS', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'GROUP/USERS'() :: #'GROUP/USERS'{}.