%% HRL file generated by ERLSOM
%%
%% It is possible (and in some cases necessary) to change the name of
%% the record fields.
%%
%% It is possible to add default values, but be aware that these will
%% only be used when *writing* an xml document.


-ifndef(ERLSOM_ANY_ATTRIB_TYPES).
-define(ERLSOM_ANY_ATTRIB_TYPES, true).
-type anyAttrib()  :: {{string(),    %% name of the attribute
                        string()},   %% namespace
                       string()}.    %% value

-type anyAttribs() :: [anyAttrib()] | undefined.
-endif.

-ifndef(ERLSOM_QNAME_TYPES).
-define(ERLSOM_QNAME_TYPES, true).
%% xsd:QName values are translated to #qname{} records.
-record(qname, {uri :: string(),
                localPart :: string(),
                prefix :: string(),
                mappedPrefix :: string()}).
-endif.



-record('HOST', {anyAttribs :: anyAttribs(),
	'ID' :: integer(),
	'NAME' :: string(),
	'STATE' :: integer(),
	'PREV_STATE' :: integer(),
	'IM_MAD' :: string(),
	'VM_MAD' :: string(),
	'CLUSTER_ID' :: integer(),
	'CLUSTER' :: string(),
	'HOST_SHARE' :: 'HOST/HOST_SHARE'(),
	'VMS' :: 'HOST/VMS'(),
	'TEMPLATE' :: 'HOST/TEMPLATE'(),
	'MONITORING' :: 'HOST/MONITORING'()}).

-type 'HOST'() :: #'HOST'{}.


-record('HOST/MONITORING', {anyAttribs :: anyAttribs(),
	'TIMESTAMP' :: integer() | undefined,
	'ID' :: integer() | undefined,
	'CAPACITY' :: 'HOST/MONITORING/CAPACITY'() | undefined,
	'SYSTEM' :: 'HOST/MONITORING/SYSTEM'() | undefined}).

-type 'HOST/MONITORING'() :: #'HOST/MONITORING'{}.


-record('HOST/MONITORING/SYSTEM', {anyAttribs :: anyAttribs(),
	'NETRX' :: integer() | undefined,
	'NETTX' :: integer() | undefined}).

-type 'HOST/MONITORING/SYSTEM'() :: #'HOST/MONITORING/SYSTEM'{}.


-record('HOST/MONITORING/CAPACITY', {anyAttribs :: anyAttribs(),
	'FREE_CPU' :: integer(),
	'FREE_MEMORY' :: integer(),
	'USED_CPU' :: integer(),
	'USED_MEMORY' :: integer()}).

-type 'HOST/MONITORING/CAPACITY'() :: #'HOST/MONITORING/CAPACITY'{}.


-record('HOST/TEMPLATE', {anyAttribs :: anyAttribs(),
	choice :: [any()] | undefined,
	'VCENTER_CCR_REF' :: string() | undefined,
	'VCENTER_DS_REF' :: [string()] | undefined,
	'VCENTER_HOST' :: string() | undefined,
	'VCENTER_INSTANCE_ID' :: string() | undefined,
	'VCENTER_NAME' :: string() | undefined,
	'VCENTER_PASSWORD' :: string() | undefined,
	'VCENTER_RESOURCE_POOL_INFO' :: [string()] | undefined,
	'VCENTER_USER' :: string() | undefined,
	'VCENTER_VERSION' :: string() | undefined,
	choice1 :: [any()] | undefined}).

-type 'HOST/TEMPLATE'() :: #'HOST/TEMPLATE'{}.


-record('HOST/VMS', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'HOST/VMS'() :: #'HOST/VMS'{}.


-record('HOST/HOST_SHARE', {anyAttribs :: anyAttribs(),
	'MEM_USAGE' :: integer(),
	'CPU_USAGE' :: integer(),
	'TOTAL_MEM' :: integer(),
	'TOTAL_CPU' :: integer(),
	'MAX_MEM' :: integer(),
	'MAX_CPU' :: integer(),
	'RUNNING_VMS' :: integer(),
	'VMS_THREAD' :: integer(),
	'DATASTORES' :: 'HOST/HOST_SHARE/DATASTORES'(),
	'PCI_DEVICES' :: 'HOST/HOST_SHARE/PCI_DEVICES'(),
	'NUMA_NODES' :: 'HOST/HOST_SHARE/NUMA_NODES'()}).

-type 'HOST/HOST_SHARE'() :: #'HOST/HOST_SHARE'{}.


-record('HOST/HOST_SHARE/NUMA_NODES', {anyAttribs :: anyAttribs(),
	'NODE' :: ['HOST/HOST_SHARE/NUMA_NODES/NODE'()] | undefined}).

-type 'HOST/HOST_SHARE/NUMA_NODES'() :: #'HOST/HOST_SHARE/NUMA_NODES'{}.


-record('HOST/HOST_SHARE/NUMA_NODES/NODE', {anyAttribs :: anyAttribs(),
	'CORE' :: ['HOST/HOST_SHARE/NUMA_NODES/NODE/CORE'()] | undefined,
	'HUGEPAGE' :: ['HOST/HOST_SHARE/NUMA_NODES/NODE/HUGEPAGE'()] | undefined,
	'MEMORY' :: 'HOST/HOST_SHARE/NUMA_NODES/NODE/MEMORY'(),
	'NODE_ID' :: integer()}).

-type 'HOST/HOST_SHARE/NUMA_NODES/NODE'() :: #'HOST/HOST_SHARE/NUMA_NODES/NODE'{}.


-record('HOST/HOST_SHARE/NUMA_NODES/NODE/MEMORY', {anyAttribs :: anyAttribs(),
	'DISTANCE' :: string(),
	'FREE' :: integer(),
	'TOTAL' :: integer(),
	'USAGE' :: integer(),
	'USED' :: integer()}).

-type 'HOST/HOST_SHARE/NUMA_NODES/NODE/MEMORY'() :: #'HOST/HOST_SHARE/NUMA_NODES/NODE/MEMORY'{}.


-record('HOST/HOST_SHARE/NUMA_NODES/NODE/HUGEPAGE', {anyAttribs :: anyAttribs(),
	'FREE' :: integer(),
	'PAGES' :: integer(),
	'SIZE' :: integer(),
	'USAGE' :: integer()}).

-type 'HOST/HOST_SHARE/NUMA_NODES/NODE/HUGEPAGE'() :: #'HOST/HOST_SHARE/NUMA_NODES/NODE/HUGEPAGE'{}.


-record('HOST/HOST_SHARE/NUMA_NODES/NODE/CORE', {anyAttribs :: anyAttribs(),
	'CPUS' :: string(),
	'DEDICATED' :: string(),
	'FREE' :: integer(),
	'ID' :: integer()}).

-type 'HOST/HOST_SHARE/NUMA_NODES/NODE/CORE'() :: #'HOST/HOST_SHARE/NUMA_NODES/NODE/CORE'{}.


-record('HOST/HOST_SHARE/PCI_DEVICES', {anyAttribs :: anyAttribs(),
	'PCI' :: [string()] | undefined}).

-type 'HOST/HOST_SHARE/PCI_DEVICES'() :: #'HOST/HOST_SHARE/PCI_DEVICES'{}.


-record('HOST/HOST_SHARE/DATASTORES', {anyAttribs :: anyAttribs(),
	'DISK_USAGE' :: integer(),
	'FREE_DISK' :: integer(),
	'MAX_DISK' :: integer(),
	'USED_DISK' :: integer()}).

-type 'HOST/HOST_SHARE/DATASTORES'() :: #'HOST/HOST_SHARE/DATASTORES'{}.