%% HRL file generated by ERLSOM
%%
%% It is possible (and in some cases necessary) to change the name of
%% the record fields.
%%
%% It is possible to add default values, but be aware that these will
%% only be used when *writing* an xml document.


-ifndef(ERLSOM_ANY_ATTRIB_TYPES).
-define(ERLSOM_ANY_ATTRIB_TYPES, true).
-type anyAttrib()  :: {{string(),    %% name of the attribute
                        string()},   %% namespace
                       string()}.    %% value

-type anyAttribs() :: [anyAttrib()] | undefined.
-endif.

-ifndef(ERLSOM_QNAME_TYPES).
-define(ERLSOM_QNAME_TYPES, true).
%% xsd:QName values are translated to #qname{} records.
-record(qname, {uri :: string(),
                localPart :: string(),
                prefix :: string(),
                mappedPrefix :: string()}).
-endif.



-record('IMAGE', {anyAttribs :: anyAttribs(),
	'ID' :: integer(),
	'UID' :: integer(),
	'GID' :: integer(),
	'UNAME' :: string(),
	'GNAME' :: string(),
	'NAME' :: string(),
	'LOCK' :: 'IMAGE/LOCK'() | undefined,
	'PERMISSIONS' :: 'IMAGE/PERMISSIONS'() | undefined,
	'TYPE' :: integer(),
	'DISK_TYPE' :: integer(),
	'PERSISTENT' :: integer(),
	'REGTIME' :: integer(),
	'SOURCE' :: string(),
	'PATH' :: string(),
	'FORMAT' :: string(),
	'FS' :: string(),
	'SIZE' :: integer(),
	'STATE' :: integer(),
	'RUNNING_VMS' :: integer(),
	'CLONING_OPS' :: integer(),
	'CLONING_ID' :: integer(),
	'TARGET_SNAPSHOT' :: integer(),
	'DATASTORE_ID' :: integer(),
	'DATASTORE' :: string(),
	'VMS' :: 'IMAGE/VMS'(),
	'CLONES' :: 'IMAGE/CLONES'(),
	'APP_CLONES' :: 'IMAGE/APP_CLONES'(),
	'TEMPLATE' :: 'IMAGE/TEMPLATE'(),
	'SNAPSHOTS' :: 'IMAGE/SNAPSHOTS'()}).

-type 'IMAGE'() :: #'IMAGE'{}.


-record('IMAGE/SNAPSHOTS', {anyAttribs :: anyAttribs(),
	'ALLOW_ORPHANS' :: string(),
	'CURRENT_BASE' :: integer(),
	'NEXT_SNAPSHOT' :: string(),
	'SNAPSHOT' :: ['IMAGE/SNAPSHOTS/SNAPSHOT'()] | undefined}).

-type 'IMAGE/SNAPSHOTS'() :: #'IMAGE/SNAPSHOTS'{}.


-record('IMAGE/SNAPSHOTS/SNAPSHOT', {anyAttribs :: anyAttribs(),
	'CHILDREN' :: string() | undefined,
	'ACTIVE' :: string() | undefined,
	'DATE' :: integer(),
	'ID' :: integer(),
	'NAME' :: string() | undefined,
	'PARENT' :: integer(),
	'SIZE' :: integer()}).

-type 'IMAGE/SNAPSHOTS/SNAPSHOT'() :: #'IMAGE/SNAPSHOTS/SNAPSHOT'{}.


-record('IMAGE/TEMPLATE', {anyAttribs :: anyAttribs(),
	choice :: [any()] | undefined,
	'VCENTER_IMPORTED' :: string() | undefined,
	choice1 :: [any()] | undefined}).

-type 'IMAGE/TEMPLATE'() :: #'IMAGE/TEMPLATE'{}.


-record('IMAGE/APP_CLONES', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'IMAGE/APP_CLONES'() :: #'IMAGE/APP_CLONES'{}.


-record('IMAGE/CLONES', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'IMAGE/CLONES'() :: #'IMAGE/CLONES'{}.


-record('IMAGE/VMS', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'IMAGE/VMS'() :: #'IMAGE/VMS'{}.


-record('IMAGE/PERMISSIONS', {anyAttribs :: anyAttribs(),
	'OWNER_U' :: integer(),
	'OWNER_M' :: integer(),
	'OWNER_A' :: integer(),
	'GROUP_U' :: integer(),
	'GROUP_M' :: integer(),
	'GROUP_A' :: integer(),
	'OTHER_U' :: integer(),
	'OTHER_M' :: integer(),
	'OTHER_A' :: integer()}).

-type 'IMAGE/PERMISSIONS'() :: #'IMAGE/PERMISSIONS'{}.


-record('IMAGE/LOCK', {anyAttribs :: anyAttribs(),
	'LOCKED' :: integer(),
	'OWNER' :: integer(),
	'TIME' :: integer(),
	'REQ_ID' :: integer()}).

-type 'IMAGE/LOCK'() :: #'IMAGE/LOCK'{}.