%% HRL file generated by ERLSOM
%%
%% It is possible (and in some cases necessary) to change the name of
%% the record fields.
%%
%% It is possible to add default values, but be aware that these will
%% only be used when *writing* an xml document.


-ifndef(ERLSOM_ANY_ATTRIB_TYPES).
-define(ERLSOM_ANY_ATTRIB_TYPES, true).
-type anyAttrib()  :: {{string(),    %% name of the attribute
                        string()},   %% namespace
                       string()}.    %% value

-type anyAttribs() :: [anyAttrib()] | undefined.
-endif.

-ifndef(ERLSOM_QNAME_TYPES).
-define(ERLSOM_QNAME_TYPES, true).
%% xsd:QName values are translated to #qname{} records.
-record(qname, {uri :: string(),
                localPart :: string(),
                prefix :: string(),
                mappedPrefix :: string()}).
-endif.



-record('SECURITY_GROUP', {anyAttribs :: anyAttribs(),
	'ID' :: integer(),
	'UID' :: integer(),
	'GID' :: integer(),
	'UNAME' :: string(),
	'GNAME' :: string(),
	'NAME' :: string(),
	'PERMISSIONS' :: 'SECURITY_GROUP/PERMISSIONS'() | undefined,
	'UPDATED_VMS' :: 'SECURITY_GROUP/UPDATED_VMS'(),
	'OUTDATED_VMS' :: 'SECURITY_GROUP/OUTDATED_VMS'(),
	'UPDATING_VMS' :: 'SECURITY_GROUP/UPDATING_VMS'(),
	'ERROR_VMS' :: 'SECURITY_GROUP/ERROR_VMS'(),
	'TEMPLATE' :: 'SECURITY_GROUP/TEMPLATE'()}).

-type 'SECURITY_GROUP'() :: #'SECURITY_GROUP'{}.


-record('SECURITY_GROUP/TEMPLATE', {anyAttribs :: anyAttribs(),
	'DESCRIPTION' :: string() | undefined,
	'RULE' :: ['SECURITY_GROUP/TEMPLATE/RULE'()] | undefined,
	'#any' :: any()}).

-type 'SECURITY_GROUP/TEMPLATE'() :: #'SECURITY_GROUP/TEMPLATE'{}.


-record('SECURITY_GROUP/TEMPLATE/RULE', {anyAttribs :: anyAttribs(),
	'PROTOCOL' :: string(),
	'RULE_TYPE' :: string()}).

-type 'SECURITY_GROUP/TEMPLATE/RULE'() :: #'SECURITY_GROUP/TEMPLATE/RULE'{}.


-record('SECURITY_GROUP/ERROR_VMS', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'SECURITY_GROUP/ERROR_VMS'() :: #'SECURITY_GROUP/ERROR_VMS'{}.


-record('SECURITY_GROUP/UPDATING_VMS', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'SECURITY_GROUP/UPDATING_VMS'() :: #'SECURITY_GROUP/UPDATING_VMS'{}.


-record('SECURITY_GROUP/OUTDATED_VMS', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'SECURITY_GROUP/OUTDATED_VMS'() :: #'SECURITY_GROUP/OUTDATED_VMS'{}.


-record('SECURITY_GROUP/UPDATED_VMS', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'SECURITY_GROUP/UPDATED_VMS'() :: #'SECURITY_GROUP/UPDATED_VMS'{}.


-record('SECURITY_GROUP/PERMISSIONS', {anyAttribs :: anyAttribs(),
	'OWNER_U' :: integer(),
	'OWNER_M' :: integer(),
	'OWNER_A' :: integer(),
	'GROUP_U' :: integer(),
	'GROUP_M' :: integer(),
	'GROUP_A' :: integer(),
	'OTHER_U' :: integer(),
	'OTHER_M' :: integer(),
	'OTHER_A' :: integer()}).

-type 'SECURITY_GROUP/PERMISSIONS'() :: #'SECURITY_GROUP/PERMISSIONS'{}.