%% HRL file generated by ERLSOM
%%
%% It is possible (and in some cases necessary) to change the name of
%% the record fields.
%%
%% It is possible to add default values, but be aware that these will
%% only be used when *writing* an xml document.


-ifndef(ERLSOM_ANY_ATTRIB_TYPES).
-define(ERLSOM_ANY_ATTRIB_TYPES, true).
-type anyAttrib()  :: {{string(),    %% name of the attribute
                        string()},   %% namespace
                       string()}.    %% value

-type anyAttribs() :: [anyAttrib()] | undefined.
-endif.

-ifndef(ERLSOM_QNAME_TYPES).
-define(ERLSOM_QNAME_TYPES, true).
%% xsd:QName values are translated to #qname{} records.
-record(qname, {uri :: string(),
                localPart :: string(),
                prefix :: string(),
                mappedPrefix :: string()}).
-endif.



-record('USER', {anyAttribs :: anyAttribs(),
	'ID' :: integer(),
	'GID' :: integer(),
	'GROUPS' :: 'USER/GROUPS'(),
	'GNAME' :: string(),
	'NAME' :: string(),
	'PASSWORD' :: string(),
	'AUTH_DRIVER' :: string(),
	'ENABLED' :: integer(),
	'LOGIN_TOKEN' :: ['USER/LOGIN_TOKEN'()] | undefined,
	'TEMPLATE' :: string(),
	'DATASTORE_QUOTA' :: 'USER/DATASTORE_QUOTA'() | undefined,
	'NETWORK_QUOTA' :: 'USER/NETWORK_QUOTA'() | undefined,
	'VM_QUOTA' :: 'USER/VM_QUOTA'() | undefined,
	'IMAGE_QUOTA' :: 'USER/IMAGE_QUOTA'() | undefined,
	'DEFAULT_USER_QUOTAS' :: 'USER/DEFAULT_USER_QUOTAS'()}).

-type 'USER'() :: #'USER'{}.


-record('USER/DEFAULT_USER_QUOTAS', {anyAttribs :: anyAttribs(),
	'DATASTORE_QUOTA' :: 'USER/DEFAULT_USER_QUOTAS/DATASTORE_QUOTA'() | undefined,
	'NETWORK_QUOTA' :: 'USER/DEFAULT_USER_QUOTAS/NETWORK_QUOTA'() | undefined,
	'VM_QUOTA' :: 'USER/DEFAULT_USER_QUOTAS/VM_QUOTA'() | undefined,
	'IMAGE_QUOTA' :: 'USER/DEFAULT_USER_QUOTAS/IMAGE_QUOTA'() | undefined}).

-type 'USER/DEFAULT_USER_QUOTAS'() :: #'USER/DEFAULT_USER_QUOTAS'{}.


-record('USER/DEFAULT_USER_QUOTAS/IMAGE_QUOTA', {anyAttribs :: anyAttribs(),
	'IMAGE' :: ['USER/DEFAULT_USER_QUOTAS/IMAGE_QUOTA/IMAGE'()] | undefined}).

-type 'USER/DEFAULT_USER_QUOTAS/IMAGE_QUOTA'() :: #'USER/DEFAULT_USER_QUOTAS/IMAGE_QUOTA'{}.


-record('USER/DEFAULT_USER_QUOTAS/IMAGE_QUOTA/IMAGE', {anyAttribs :: anyAttribs(),
	'ID' :: string(),
	'RVMS' :: string(),
	'RVMS_USED' :: string()}).

-type 'USER/DEFAULT_USER_QUOTAS/IMAGE_QUOTA/IMAGE'() :: #'USER/DEFAULT_USER_QUOTAS/IMAGE_QUOTA/IMAGE'{}.


-record('USER/DEFAULT_USER_QUOTAS/VM_QUOTA', {anyAttribs :: anyAttribs(),
	'VM' :: 'USER/DEFAULT_USER_QUOTAS/VM_QUOTA/VM'() | undefined}).

-type 'USER/DEFAULT_USER_QUOTAS/VM_QUOTA'() :: #'USER/DEFAULT_USER_QUOTAS/VM_QUOTA'{}.


-record('USER/DEFAULT_USER_QUOTAS/VM_QUOTA/VM', {anyAttribs :: anyAttribs(),
	'CPU' :: string(),
	'CPU_USED' :: string(),
	'MEMORY' :: string(),
	'MEMORY_USED' :: string(),
	'RUNNING_CPU' :: string(),
	'RUNNING_CPU_USED' :: string(),
	'RUNNING_MEMORY' :: string(),
	'RUNNING_MEMORY_USED' :: string(),
	'RUNNING_VMS' :: string(),
	'RUNNING_VMS_USED' :: string(),
	'SYSTEM_DISK_SIZE' :: string(),
	'SYSTEM_DISK_SIZE_USED' :: string(),
	'VMS' :: string(),
	'VMS_USED' :: string()}).

-type 'USER/DEFAULT_USER_QUOTAS/VM_QUOTA/VM'() :: #'USER/DEFAULT_USER_QUOTAS/VM_QUOTA/VM'{}.


-record('USER/DEFAULT_USER_QUOTAS/NETWORK_QUOTA', {anyAttribs :: anyAttribs(),
	'NETWORK' :: ['USER/DEFAULT_USER_QUOTAS/NETWORK_QUOTA/NETWORK'()] | undefined}).

-type 'USER/DEFAULT_USER_QUOTAS/NETWORK_QUOTA'() :: #'USER/DEFAULT_USER_QUOTAS/NETWORK_QUOTA'{}.


-record('USER/DEFAULT_USER_QUOTAS/NETWORK_QUOTA/NETWORK', {anyAttribs :: anyAttribs(),
	'ID' :: string(),
	'LEASES' :: string(),
	'LEASES_USED' :: string()}).

-type 'USER/DEFAULT_USER_QUOTAS/NETWORK_QUOTA/NETWORK'() :: #'USER/DEFAULT_USER_QUOTAS/NETWORK_QUOTA/NETWORK'{}.


-record('USER/DEFAULT_USER_QUOTAS/DATASTORE_QUOTA', {anyAttribs :: anyAttribs(),
	'DATASTORE' :: ['USER/DEFAULT_USER_QUOTAS/DATASTORE_QUOTA/DATASTORE'()] | undefined}).

-type 'USER/DEFAULT_USER_QUOTAS/DATASTORE_QUOTA'() :: #'USER/DEFAULT_USER_QUOTAS/DATASTORE_QUOTA'{}.


-record('USER/DEFAULT_USER_QUOTAS/DATASTORE_QUOTA/DATASTORE', {anyAttribs :: anyAttribs(),
	'ID' :: string(),
	'IMAGES' :: string(),
	'IMAGES_USED' :: string(),
	'SIZE' :: string(),
	'SIZE_USED' :: string()}).

-type 'USER/DEFAULT_USER_QUOTAS/DATASTORE_QUOTA/DATASTORE'() :: #'USER/DEFAULT_USER_QUOTAS/DATASTORE_QUOTA/DATASTORE'{}.


-record('USER/IMAGE_QUOTA', {anyAttribs :: anyAttribs(),
	'IMAGE' :: ['USER/IMAGE_QUOTA/IMAGE'()] | undefined}).

-type 'USER/IMAGE_QUOTA'() :: #'USER/IMAGE_QUOTA'{}.


-record('USER/IMAGE_QUOTA/IMAGE', {anyAttribs :: anyAttribs(),
	'ID' :: string(),
	'RVMS' :: string(),
	'RVMS_USED' :: string()}).

-type 'USER/IMAGE_QUOTA/IMAGE'() :: #'USER/IMAGE_QUOTA/IMAGE'{}.


-record('USER/VM_QUOTA', {anyAttribs :: anyAttribs(),
	'VM' :: 'USER/VM_QUOTA/VM'() | undefined}).

-type 'USER/VM_QUOTA'() :: #'USER/VM_QUOTA'{}.


-record('USER/VM_QUOTA/VM', {anyAttribs :: anyAttribs(),
	'CPU' :: string(),
	'CPU_USED' :: string(),
	'MEMORY' :: string(),
	'MEMORY_USED' :: string(),
	'RUNNING_CPU' :: string(),
	'RUNNING_CPU_USED' :: string(),
	'RUNNING_MEMORY' :: string(),
	'RUNNING_MEMORY_USED' :: string(),
	'RUNNING_VMS' :: string(),
	'RUNNING_VMS_USED' :: string(),
	'SYSTEM_DISK_SIZE' :: string(),
	'SYSTEM_DISK_SIZE_USED' :: string(),
	'VMS' :: string(),
	'VMS_USED' :: string()}).

-type 'USER/VM_QUOTA/VM'() :: #'USER/VM_QUOTA/VM'{}.


-record('USER/NETWORK_QUOTA', {anyAttribs :: anyAttribs(),
	'NETWORK' :: ['USER/NETWORK_QUOTA/NETWORK'()] | undefined}).

-type 'USER/NETWORK_QUOTA'() :: #'USER/NETWORK_QUOTA'{}.


-record('USER/NETWORK_QUOTA/NETWORK', {anyAttribs :: anyAttribs(),
	'ID' :: string(),
	'LEASES' :: string(),
	'LEASES_USED' :: string()}).

-type 'USER/NETWORK_QUOTA/NETWORK'() :: #'USER/NETWORK_QUOTA/NETWORK'{}.


-record('USER/DATASTORE_QUOTA', {anyAttribs :: anyAttribs(),
	'DATASTORE' :: ['USER/DATASTORE_QUOTA/DATASTORE'()] | undefined}).

-type 'USER/DATASTORE_QUOTA'() :: #'USER/DATASTORE_QUOTA'{}.


-record('USER/DATASTORE_QUOTA/DATASTORE', {anyAttribs :: anyAttribs(),
	'ID' :: string(),
	'IMAGES' :: string(),
	'IMAGES_USED' :: string(),
	'SIZE' :: string(),
	'SIZE_USED' :: string()}).

-type 'USER/DATASTORE_QUOTA/DATASTORE'() :: #'USER/DATASTORE_QUOTA/DATASTORE'{}.


-record('USER/LOGIN_TOKEN', {anyAttribs :: anyAttribs(),
	'TOKEN' :: string(),
	'EXPIRATION_TIME' :: integer(),
	'EGID' :: integer()}).

-type 'USER/LOGIN_TOKEN'() :: #'USER/LOGIN_TOKEN'{}.


-record('USER/GROUPS', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()]}).

-type 'USER/GROUPS'() :: #'USER/GROUPS'{}.