%% HRL file generated by ERLSOM
%%
%% It is possible (and in some cases necessary) to change the name of
%% the record fields.
%%
%% It is possible to add default values, but be aware that these will
%% only be used when *writing* an xml document.


-ifndef(ERLSOM_ANY_ATTRIB_TYPES).
-define(ERLSOM_ANY_ATTRIB_TYPES, true).
-type anyAttrib()  :: {{string(),    %% name of the attribute
                        string()},   %% namespace
                       string()}.    %% value

-type anyAttribs() :: [anyAttrib()] | undefined.
-endif.

-ifndef(ERLSOM_QNAME_TYPES).
-define(ERLSOM_QNAME_TYPES, true).
%% xsd:QName values are translated to #qname{} records.
-record(qname, {uri :: string(),
                localPart :: string(),
                prefix :: string(),
                mappedPrefix :: string()}).
-endif.



-record('VDC', {anyAttribs :: anyAttribs(),
	'ID' :: integer(),
	'NAME' :: string(),
	'GROUPS' :: 'VDC/GROUPS'(),
	'CLUSTERS' :: 'VDC/CLUSTERS'(),
	'HOSTS' :: 'VDC/HOSTS'(),
	'DATASTORES' :: 'VDC/DATASTORES'(),
	'VNETS' :: 'VDC/VNETS'(),
	'TEMPLATE' :: string()}).

-type 'VDC'() :: #'VDC'{}.


-record('VDC/VNETS', {anyAttribs :: anyAttribs(),
	'VNET' :: ['VDC/VNETS/VNET'()] | undefined}).

-type 'VDC/VNETS'() :: #'VDC/VNETS'{}.


-record('VDC/VNETS/VNET', {anyAttribs :: anyAttribs(),
	'ZONE_ID' :: integer(),
	'VNET_ID' :: integer()}).

-type 'VDC/VNETS/VNET'() :: #'VDC/VNETS/VNET'{}.


-record('VDC/DATASTORES', {anyAttribs :: anyAttribs(),
	'DATASTORE' :: ['VDC/DATASTORES/DATASTORE'()] | undefined}).

-type 'VDC/DATASTORES'() :: #'VDC/DATASTORES'{}.


-record('VDC/DATASTORES/DATASTORE', {anyAttribs :: anyAttribs(),
	'ZONE_ID' :: integer(),
	'DATASTORE_ID' :: integer()}).

-type 'VDC/DATASTORES/DATASTORE'() :: #'VDC/DATASTORES/DATASTORE'{}.


-record('VDC/HOSTS', {anyAttribs :: anyAttribs(),
	'HOST' :: ['VDC/HOSTS/HOST'()] | undefined}).

-type 'VDC/HOSTS'() :: #'VDC/HOSTS'{}.


-record('VDC/HOSTS/HOST', {anyAttribs :: anyAttribs(),
	'ZONE_ID' :: integer(),
	'HOST_ID' :: integer()}).

-type 'VDC/HOSTS/HOST'() :: #'VDC/HOSTS/HOST'{}.


-record('VDC/CLUSTERS', {anyAttribs :: anyAttribs(),
	'CLUSTER' :: ['VDC/CLUSTERS/CLUSTER'()] | undefined}).

-type 'VDC/CLUSTERS'() :: #'VDC/CLUSTERS'{}.


-record('VDC/CLUSTERS/CLUSTER', {anyAttribs :: anyAttribs(),
	'ZONE_ID' :: integer(),
	'CLUSTER_ID' :: integer()}).

-type 'VDC/CLUSTERS/CLUSTER'() :: #'VDC/CLUSTERS/CLUSTER'{}.


-record('VDC/GROUPS', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'VDC/GROUPS'() :: #'VDC/GROUPS'{}.