%% HRL file generated by ERLSOM
%%
%% It is possible (and in some cases necessary) to change the name of
%% the record fields.
%%
%% It is possible to add default values, but be aware that these will
%% only be used when *writing* an xml document.


-ifndef(ERLSOM_ANY_ATTRIB_TYPES).
-define(ERLSOM_ANY_ATTRIB_TYPES, true).
-type anyAttrib()  :: {{string(),    %% name of the attribute
                        string()},   %% namespace
                       string()}.    %% value

-type anyAttribs() :: [anyAttrib()] | undefined.
-endif.

-ifndef(ERLSOM_QNAME_TYPES).
-define(ERLSOM_QNAME_TYPES, true).
%% xsd:QName values are translated to #qname{} records.
-record(qname, {uri :: string(),
                localPart :: string(),
                prefix :: string(),
                mappedPrefix :: string()}).
-endif.



-record('VM', {anyAttribs :: anyAttribs(),
	'ID' :: integer(),
	'UID' :: integer(),
	'GID' :: integer(),
	'UNAME' :: string(),
	'GNAME' :: string(),
	'NAME' :: string(),
	'PERMISSIONS' :: 'VM/PERMISSIONS'() | undefined,
	'LAST_POLL' :: integer(),
	'STATE' :: integer(),
	'LCM_STATE' :: integer(),
	'PREV_STATE' :: integer(),
	'PREV_LCM_STATE' :: integer(),
	'RESCHED' :: integer(),
	'STIME' :: integer(),
	'ETIME' :: integer(),
	'DEPLOY_ID' :: string(),
	'LOCK' :: 'VM/LOCK'() | undefined,
	'MONITORING' :: 'VM/MONITORING'(),
	'TEMPLATE' :: 'VM/TEMPLATE'(),
	'USER_TEMPLATE' :: 'VM/USER_TEMPLATE'(),
	'HISTORY_RECORDS' :: 'VM/HISTORY_RECORDS'(),
	'SNAPSHOTS' :: ['VM/SNAPSHOTS'()] | undefined}).

-type 'VM'() :: #'VM'{}.


-record('VM/SNAPSHOTS', {anyAttribs :: anyAttribs(),
	'ALLOW_ORPHANS' :: string(),
	'CURRENT_BASE' :: integer(),
	'DISK_ID' :: integer(),
	'NEXT_SNAPSHOT' :: integer(),
	'SNAPSHOT' :: ['VM/SNAPSHOTS/SNAPSHOT'()] | undefined}).

-type 'VM/SNAPSHOTS'() :: #'VM/SNAPSHOTS'{}.


-record('VM/SNAPSHOTS/SNAPSHOT', {anyAttribs :: anyAttribs(),
	'ACTIVE' :: string() | undefined,
	'CHILDREN' :: string() | undefined,
	'DATE' :: integer(),
	'ID' :: integer(),
	'NAME' :: string() | undefined,
	'PARENT' :: integer(),
	'SIZE' :: integer()}).

-type 'VM/SNAPSHOTS/SNAPSHOT'() :: #'VM/SNAPSHOTS/SNAPSHOT'{}.


-record('VM/HISTORY_RECORDS', {anyAttribs :: anyAttribs(),
	'HISTORY' :: ['VM/HISTORY_RECORDS/HISTORY'()] | undefined}).

-type 'VM/HISTORY_RECORDS'() :: #'VM/HISTORY_RECORDS'{}.


-record('VM/HISTORY_RECORDS/HISTORY', {anyAttribs :: anyAttribs(),
	'OID' :: integer(),
	'SEQ' :: integer(),
	'HOSTNAME' :: string(),
	'HID' :: integer(),
	'CID' :: integer(),
	'STIME' :: integer(),
	'ETIME' :: integer(),
	'VM_MAD' :: string(),
	'TM_MAD' :: string(),
	'DS_ID' :: integer(),
	'PSTIME' :: integer(),
	'PETIME' :: integer(),
	'RSTIME' :: integer(),
	'RETIME' :: integer(),
	'ESTIME' :: integer(),
	'EETIME' :: integer(),
	'ACTION' :: integer(),
	'UID' :: integer(),
	'GID' :: integer(),
	'REQUEST_ID' :: string()}).

-type 'VM/HISTORY_RECORDS/HISTORY'() :: #'VM/HISTORY_RECORDS/HISTORY'{}.


-record('VM/USER_TEMPLATE', {anyAttribs :: anyAttribs(),
	choice :: [any()] | undefined,
	'VCENTER_CCR_REF' :: string() | undefined,
	'VCENTER_DS_REF' :: string() | undefined,
	'VCENTER_INSTANCE_ID' :: string() | undefined,
	choice1 :: [any()] | undefined}).

-type 'VM/USER_TEMPLATE'() :: #'VM/USER_TEMPLATE'{}.


-record('VM/TEMPLATE', {anyAttribs :: anyAttribs(),
	choice :: [any()] | undefined,
	'DISK' :: ['VM/TEMPLATE/DISK'()] | undefined,
	choice1 :: [any()] | undefined,
	'NIC' :: ['VM/TEMPLATE/NIC'()] | undefined,
	choice2 :: [any()] | undefined,
	'NIC_ALIAS' :: ['VM/TEMPLATE/NIC_ALIAS'()] | undefined,
	choice3 :: [any()] | undefined}).

-type 'VM/TEMPLATE'() :: #'VM/TEMPLATE'{}.


-record('VM/TEMPLATE/NIC_ALIAS', {anyAttribs :: anyAttribs(),
	'ALIAS_ID' :: string(),
	choice :: [any()] | undefined,
	'PARENT' :: string(),
	'PARENT_ID' :: string(),
	choice1 :: [any()] | undefined,
	'VCENTER_INSTANCE_ID' :: string() | undefined,
	'VCENTER_NET_REF' :: string() | undefined,
	'VCENTER_PORTGROUP_TYPE' :: string() | undefined}).

-type 'VM/TEMPLATE/NIC_ALIAS'() :: #'VM/TEMPLATE/NIC_ALIAS'{}.


-record('VM/TEMPLATE/NIC', {anyAttribs :: anyAttribs(),
	choice :: [any()] | undefined,
	'BRIDGE_TYPE' :: string(),
	choice1 :: [any()] | undefined,
	'VCENTER_INSTANCE_ID' :: string() | undefined,
	'VCENTER_NET_REF' :: string() | undefined,
	'VCENTER_PORTGROUP_TYPE' :: string() | undefined}).

-type 'VM/TEMPLATE/NIC'() :: #'VM/TEMPLATE/NIC'{}.


-record('VM/TEMPLATE/DISK', {anyAttribs :: anyAttribs(),
	choice :: [any()] | undefined,
	'VCENTER_DS_REF' :: string() | undefined,
	'VCENTER_INSTANCE_ID' :: string() | undefined,
	choice1 :: [any()] | undefined}).

-type 'VM/TEMPLATE/DISK'() :: #'VM/TEMPLATE/DISK'{}.


-record('VM/MONITORING', {anyAttribs :: anyAttribs(),
	'CPU' :: string() | undefined,
	'DISKRDBYTES' :: integer() | undefined,
	'DISKRDIOPS' :: integer() | undefined,
	'DISKWRBYTES' :: integer() | undefined,
	'DISKWRIOPS' :: integer() | undefined,
	'ID' :: integer() | undefined,
	'MEMORY' :: integer() | undefined,
	'NETTX' :: integer() | undefined,
	'NETRX' :: integer() | undefined,
	'TIMESTAMP' :: integer() | undefined,
	'VCENTER_ESX_HOST' :: string() | undefined,
	'VCENTER_GUEST_STATE' :: string() | undefined,
	'VCENTER_RP_NAME' :: string() | undefined,
	'VCENTER_VMWARETOOLS_RUNNING_STATUS' :: string() | undefined,
	'VCENTER_VMWARETOOLS_VERSION' :: string() | undefined,
	'VCENTER_VMWARETOOLS_VERSION_STATUS' :: string() | undefined,
	'VCENTER_VM_NAME' :: string() | undefined}).

-type 'VM/MONITORING'() :: #'VM/MONITORING'{}.


-record('VM/LOCK', {anyAttribs :: anyAttribs(),
	'LOCKED' :: integer(),
	'OWNER' :: integer(),
	'TIME' :: integer(),
	'REQ_ID' :: integer()}).

-type 'VM/LOCK'() :: #'VM/LOCK'{}.


-record('VM/PERMISSIONS', {anyAttribs :: anyAttribs(),
	'OWNER_U' :: integer(),
	'OWNER_M' :: integer(),
	'OWNER_A' :: integer(),
	'GROUP_U' :: integer(),
	'GROUP_M' :: integer(),
	'GROUP_A' :: integer(),
	'OTHER_U' :: integer(),
	'OTHER_M' :: integer(),
	'OTHER_A' :: integer()}).

-type 'VM/PERMISSIONS'() :: #'VM/PERMISSIONS'{}.