%% HRL file generated by ERLSOM
%%
%% It is possible (and in some cases necessary) to change the name of
%% the record fields.
%%
%% It is possible to add default values, but be aware that these will
%% only be used when *writing* an xml document.


-ifndef(ERLSOM_ANY_ATTRIB_TYPES).
-define(ERLSOM_ANY_ATTRIB_TYPES, true).
-type anyAttrib()  :: {{string(),    %% name of the attribute
                        string()},   %% namespace
                       string()}.    %% value

-type anyAttribs() :: [anyAttrib()] | undefined.
-endif.

-ifndef(ERLSOM_QNAME_TYPES).
-define(ERLSOM_QNAME_TYPES, true).
%% xsd:QName values are translated to #qname{} records.
-record(qname, {uri :: string(),
                localPart :: string(),
                prefix :: string(),
                mappedPrefix :: string()}).
-endif.



-record('VM_POOL', {anyAttribs :: anyAttribs(),
	'VM' :: ['VM_POOL/VM'()] | undefined}).

-type 'VM_POOL'() :: #'VM_POOL'{}.


-record('VM_POOL/VM', {anyAttribs :: anyAttribs(),
	'ID' :: integer(),
	'UID' :: integer(),
	'GID' :: integer(),
	'UNAME' :: string(),
	'GNAME' :: string(),
	'NAME' :: string(),
	'LAST_POLL' :: integer(),
	'STATE' :: integer(),
	'LCM_STATE' :: integer(),
	'RESCHED' :: integer(),
	'STIME' :: integer(),
	'ETIME' :: integer(),
	'DEPLOY_ID' :: string(),
	'TEMPLATE' :: 'VM_POOL/VM/TEMPLATE'(),
	'MONITORING' :: 'VM_POOL/VM/MONITORING'() | undefined,
	'USER_TEMPLATE' :: 'VM_POOL/VM/USER_TEMPLATE'(),
	'HISTORY_RECORDS' :: 'VM_POOL/VM/HISTORY_RECORDS'(),
	'SNAPSHOTS' :: ['VM_POOL/VM/SNAPSHOTS'()] | undefined}).

-type 'VM_POOL/VM'() :: #'VM_POOL/VM'{}.


-record('VM_POOL/VM/SNAPSHOTS', {anyAttribs :: anyAttribs(),
	'ALLOW_ORPHANS' :: string(),
	'CURRENT_BASE' :: integer(),
	'DISK_ID' :: integer(),
	'NEXT_SNAPSHOT' :: integer(),
	'SNAPSHOT' :: ['VM_POOL/VM/SNAPSHOTS/SNAPSHOT'()] | undefined}).

-type 'VM_POOL/VM/SNAPSHOTS'() :: #'VM_POOL/VM/SNAPSHOTS'{}.


-record('VM_POOL/VM/SNAPSHOTS/SNAPSHOT', {anyAttribs :: anyAttribs(),
	'ACTIVE' :: string() | undefined,
	'CHILDREN' :: string() | undefined,
	'DATE' :: integer(),
	'ID' :: integer(),
	'NAME' :: string() | undefined,
	'PARENT' :: integer(),
	'SIZE' :: integer()}).

-type 'VM_POOL/VM/SNAPSHOTS/SNAPSHOT'() :: #'VM_POOL/VM/SNAPSHOTS/SNAPSHOT'{}.


-record('VM_POOL/VM/HISTORY_RECORDS', {anyAttribs :: anyAttribs(),
	'HISTORY' :: ['VM_POOL/VM/HISTORY_RECORDS/HISTORY'()] | undefined}).

-type 'VM_POOL/VM/HISTORY_RECORDS'() :: #'VM_POOL/VM/HISTORY_RECORDS'{}.


-record('VM_POOL/VM/HISTORY_RECORDS/HISTORY', {anyAttribs :: anyAttribs(),
	'OID' :: integer(),
	'SEQ' :: integer(),
	'HOSTNAME' :: string(),
	'HID' :: integer(),
	'CID' :: integer(),
	'DS_ID' :: integer(),
	'ACTION' :: integer()}).

-type 'VM_POOL/VM/HISTORY_RECORDS/HISTORY'() :: #'VM_POOL/VM/HISTORY_RECORDS/HISTORY'{}.


-record('VM_POOL/VM/USER_TEMPLATE', {anyAttribs :: anyAttribs(),
	choice :: [any()] | undefined}).

-type 'VM_POOL/VM/USER_TEMPLATE'() :: #'VM_POOL/VM/USER_TEMPLATE'{}.


-record('VM_POOL/VM/MONITORING', {anyAttribs :: anyAttribs(),
	choice :: [any()] | undefined}).

-type 'VM_POOL/VM/MONITORING'() :: #'VM_POOL/VM/MONITORING'{}.


-record('VM_POOL/VM/TEMPLATE', {anyAttribs :: anyAttribs(),
	choice :: [any()] | undefined,
	'DISK' :: ['VM_POOL/VM/TEMPLATE/DISK'()] | undefined,
	choice1 :: [any()] | undefined,
	'NIC' :: ['VM_POOL/VM/TEMPLATE/NIC'()] | undefined,
	choice2 :: [any()] | undefined}).

-type 'VM_POOL/VM/TEMPLATE'() :: #'VM_POOL/VM/TEMPLATE'{}.


-record('VM_POOL/VM/TEMPLATE/NIC', {anyAttribs :: anyAttribs(),
	choice :: [any()] | undefined,
	'VCENTER_INSTANCE_ID' :: string() | undefined,
	'VCENTER_NET_REF' :: string() | undefined,
	'VCENTER_PORTGROUP_TYPE' :: string() | undefined}).

-type 'VM_POOL/VM/TEMPLATE/NIC'() :: #'VM_POOL/VM/TEMPLATE/NIC'{}.


-record('VM_POOL/VM/TEMPLATE/DISK', {anyAttribs :: anyAttribs(),
	choice :: [any()] | undefined,
	'VCENTER_DS_REF' :: string() | undefined,
	'VCENTER_INSTANCE_ID' :: string() | undefined,
	choice1 :: [any()] | undefined}).

-type 'VM_POOL/VM/TEMPLATE/DISK'() :: #'VM_POOL/VM/TEMPLATE/DISK'{}.