%% HRL file generated by ERLSOM
%%
%% It is possible (and in some cases necessary) to change the name of
%% the record fields.
%%
%% It is possible to add default values, but be aware that these will
%% only be used when *writing* an xml document.


-ifndef(ERLSOM_ANY_ATTRIB_TYPES).
-define(ERLSOM_ANY_ATTRIB_TYPES, true).
-type anyAttrib()  :: {{string(),    %% name of the attribute
                        string()},   %% namespace
                       string()}.    %% value

-type anyAttribs() :: [anyAttrib()] | undefined.
-endif.

-ifndef(ERLSOM_QNAME_TYPES).
-define(ERLSOM_QNAME_TYPES, true).
%% xsd:QName values are translated to #qname{} records.
-record(qname, {uri :: string(),
                localPart :: string(),
                prefix :: string(),
                mappedPrefix :: string()}).
-endif.



-record('VNET', {anyAttribs :: anyAttribs(),
	'ID' :: integer(),
	'UID' :: integer(),
	'GID' :: integer(),
	'UNAME' :: string(),
	'GNAME' :: string(),
	'NAME' :: string(),
	'LOCK' :: 'VNET/LOCK'() | undefined,
	'PERMISSIONS' :: 'VNET/PERMISSIONS'() | undefined,
	'CLUSTERS' :: 'VNET/CLUSTERS'(),
	'BRIDGE' :: string(),
	'BRIDGE_TYPE' :: string() | undefined,
	'PARENT_NETWORK_ID' :: string(),
	'VN_MAD' :: string(),
	'PHYDEV' :: string(),
	'VLAN_ID' :: string() | undefined,
	'OUTER_VLAN_ID' :: string() | undefined,
	'VLAN_ID_AUTOMATIC' :: string(),
	'OUTER_VLAN_ID_AUTOMATIC' :: string(),
	'USED_LEASES' :: integer(),
	'VROUTERS' :: 'VNET/VROUTERS'(),
	'TEMPLATE' :: 'VNET/TEMPLATE'(),
	'AR_POOL' :: 'VNET/AR_POOL'()}).

-type 'VNET'() :: #'VNET'{}.


-record('VNET/AR_POOL', {anyAttribs :: anyAttribs(),
	'VNET/AR_POOL/SEQ1' :: 'VNET/AR_POOL/SEQ1'() | undefined}).

-type 'VNET/AR_POOL'() :: #'VNET/AR_POOL'{}.


-record('VNET/AR_POOL/SEQ1', {anyAttribs :: anyAttribs(),
	'AR' :: ['VNET/AR_POOL/SEQ1/AR'()] | undefined}).

-type 'VNET/AR_POOL/SEQ1'() :: #'VNET/AR_POOL/SEQ1'{}.


-record('VNET/AR_POOL/SEQ1/AR', {anyAttribs :: anyAttribs(),
	'AR_ID' :: string(),
	'GLOBAL_PREFIX' :: string() | undefined,
	'IP' :: string() | undefined,
	'MAC' :: string(),
	'PARENT_NETWORK_AR_ID' :: string() | undefined,
	'SIZE' :: integer(),
	'TYPE' :: string(),
	'ULA_PREFIX' :: string() | undefined,
	'VN_MAD' :: string() | undefined,
	'MAC_END' :: string() | undefined,
	'IP_END' :: string() | undefined,
	'IP6_ULA' :: string() | undefined,
	'IP6_ULA_END' :: string() | undefined,
	'IP6_GLOBAL' :: string() | undefined,
	'IP6_GLOBAL_END' :: string() | undefined,
	'IP6' :: string() | undefined,
	'IP6_END' :: string() | undefined,
	'USED_LEASES' :: string(),
	'LEASES' :: 'VNET/AR_POOL/SEQ1/AR/LEASES'() | undefined}).

-type 'VNET/AR_POOL/SEQ1/AR'() :: #'VNET/AR_POOL/SEQ1/AR'{}.


-record('VNET/AR_POOL/SEQ1/AR/LEASES', {anyAttribs :: anyAttribs(),
	'LEASE' :: ['VNET/AR_POOL/SEQ1/AR/LEASES/LEASE'()] | undefined}).

-type 'VNET/AR_POOL/SEQ1/AR/LEASES'() :: #'VNET/AR_POOL/SEQ1/AR/LEASES'{}.


-record('VNET/AR_POOL/SEQ1/AR/LEASES/LEASE', {anyAttribs :: anyAttribs(),
	'IP' :: string() | undefined,
	'IP6' :: string() | undefined,
	'IP6_GLOBAL' :: string() | undefined,
	'IP6_LINK' :: string() | undefined,
	'IP6_ULA' :: string() | undefined,
	'MAC' :: string(),
	'VM' :: integer() | undefined,
	'VNET' :: integer() | undefined,
	'VROUTER' :: integer() | undefined}).

-type 'VNET/AR_POOL/SEQ1/AR/LEASES/LEASE'() :: #'VNET/AR_POOL/SEQ1/AR/LEASES/LEASE'{}.


-record('VNET/TEMPLATE', {anyAttribs :: anyAttribs(),
	choice :: [any()] | undefined,
	'CONTEXT_FORCE_IPV4' :: string() | undefined,
	'DNS' :: string() | undefined,
	'GATEWAY' :: string() | undefined,
	'GATEWAY6' :: string() | undefined,
	'GUEST_MTU' :: integer() | undefined,
	'NETWORK_ADDRESS' :: string() | undefined,
	'NETWORK_MASK' :: string() | undefined,
	'SEARCH_DOMAIN' :: string() | undefined,
	'VCENTER_FROM_WILD' :: string() | undefined,
	'VCENTER_INSTANCE_ID' :: string() | undefined,
	'VCENTER_NET_REF' :: string() | undefined,
	'VCENTER_PORTGROUP_TYPE' :: string() | undefined,
	'VCENTER_TEMPLATE_REF' :: string() | undefined,
	choice1 :: [any()] | undefined}).

-type 'VNET/TEMPLATE'() :: #'VNET/TEMPLATE'{}.


-record('VNET/VROUTERS', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'VNET/VROUTERS'() :: #'VNET/VROUTERS'{}.


-record('VNET/CLUSTERS', {anyAttribs :: anyAttribs(),
	'ID' :: [integer()] | undefined}).

-type 'VNET/CLUSTERS'() :: #'VNET/CLUSTERS'{}.


-record('VNET/PERMISSIONS', {anyAttribs :: anyAttribs(),
	'OWNER_U' :: integer(),
	'OWNER_M' :: integer(),
	'OWNER_A' :: integer(),
	'GROUP_U' :: integer(),
	'GROUP_M' :: integer(),
	'GROUP_A' :: integer(),
	'OTHER_U' :: integer(),
	'OTHER_M' :: integer(),
	'OTHER_A' :: integer()}).

-type 'VNET/PERMISSIONS'() :: #'VNET/PERMISSIONS'{}.


-record('VNET/LOCK', {anyAttribs :: anyAttribs(),
	'LOCKED' :: integer(),
	'OWNER' :: integer(),
	'TIME' :: integer(),
	'REQ_ID' :: integer()}).

-type 'VNET/LOCK'() :: #'VNET/LOCK'{}.