require Logger

case RecycledCloud.LDAPTestEnvironment.start() do
  {:ok, _port, name} ->
    ExUnit.start()
    Ecto.Adapters.SQL.Sandbox.mode(RecycledCloud.Repo, :manual)

    System.at_exit(fn _code ->
      RecycledCloud.LDAPTestEnvironment.stop(name)
    end)
  {:error, _err} ->
    Logger.error("Could not start LDAP Test Environment.")
    System.stop(1)
end
